package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;
import java.util.Scanner;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        char[] arr = str.toCharArray();
        arr[arr.length/2] = Character.toUpperCase(arr[arr.length/2]);
        String string = new String(arr);
        return string;
    }

    public static String lowerCaseMiddleCharacter(String str) {
        char[] arr = str.toCharArray();
        arr[arr.length/2] = Character.toLowerCase(arr[arr.length/2]);
        String string = new String(arr);
        return string;
    }

    public static Boolean isIsogram(String str) {
        int len = str.length();

        char arr[] = str.toCharArray();

        Arrays.sort(arr);
        for (int i = 0; i < len - 1; i++) {
            if (arr[i] == arr[i + 1])
                return false;
        }
        return true;
    }



    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        for (int i = 1; i <str.length() ; i++) {
            if (str.charAt(i) == str.charAt(i - 1))
                return true;
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        if (str == null) {
            return str;
        }
        if (str.length() == 1) {
            return str;
        }
        while ( isValid(str)) {
            int length = str.length();
            int firstIndex = 0;
            boolean findConsecutiveDuplicates = false;
            int i;
            for (i = 1; i < length; i++) {
                if (str.charAt(i) == str.charAt(i - 1)) {
                    findConsecutiveDuplicates = true;
                    firstIndex = i + 1;
                } else {
                    if (findConsecutiveDuplicates) {
                        str = str.substring(firstIndex);
                        break;
                    }
                    int prev = i - 1;
                    StringBuilder sb = new StringBuilder();
                    while (i < length) {
                        if (!findConsecutiveDuplicates && str.charAt(prev) != str.charAt(i)) {
                            sb.append(str.charAt(prev));
                            prev = i;
                        } else {
                            findConsecutiveDuplicates = true;
                            if (findConsecutiveDuplicates && str.charAt(prev) != str.charAt(i)) {
                                sb.append(str.substring(i));
                                break;
                            }
                        }
                        i++;
                    }
                    if (!findConsecutiveDuplicates) {
                        sb.append(str.charAt(i - 1));
                    }
                    str = sb.toString();
                    break;
                }
            }
            if (i == str.length()) {
                str = str.substring(firstIndex);
            }
        }
        return str;
    }

    public static String invertCasing(String str) {
        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++)
        {
            char c = chars[i];
            if (Character.isUpperCase(c))
            {
                chars[i] = Character.toLowerCase(c);
            }
            else if (Character.isLowerCase(c))
            {
                chars[i] = Character.toUpperCase(c);
            }
        }
        return new String(chars);
    }

    public static boolean isValid(String string) {
        for (int i = 1; i < string.length(); i++) {
            if (string.charAt(i - 1) == string.charAt(i)) {
                return true;
            }
        }
        return false;
    }

}